/*
 * This Software (C) Copyright David Goodwin, 2008, 2009.
 * 
 *   This is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 * 
 *  This software is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with this software; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package iasel.gui;

import iasel.data.REntry;
import java.util.ArrayList;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import javax.swing.table.DefaultTableModel;

/** This widget provides a simple results table.
 *
 * @author  David
 */
public class ResultsTable extends javax.swing.JPanel {
    
    private DefaultTableModel dtm;
    
    private ArrayList<REntry> entries = new ArrayList<REntry>();
    
    /** Creates new form ResultsTable */
    public ResultsTable() {
        initComponents();
        dtm = (DefaultTableModel)resultsDisplay.getModel();
        ListSelectionModel lsm = resultsDisplay.getSelectionModel();
        lsm.setSelectionInterval(0,0);
        lsm.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    }
    
    public void addRow(REntry e) {
        entries.add(e);
        dtm.addRow(e.getData());
    }
    
    public ArrayList<REntry> getRows() {
        return entries;
    }
    
    public void clearResults() {
        int result = JOptionPane.showConfirmDialog(null,"Really clear ALL results?", "Confirm", JOptionPane.OK_CANCEL_OPTION);
        if (result == JOptionPane.OK_OPTION) {
            entries.clear();
            int j = dtm.getRowCount();
            for (int i = 0; i < j; i++)
            dtm.removeRow(0);            
        }
            
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        resultsDisplay = new javax.swing.JTable();

        setName("Form"); // NOI18N
        setLayout(new java.awt.BorderLayout());

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        resultsDisplay.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Filename", "Tag", "Frame Pixels", "Selected Pixels", "Selected Percentage", "Selected Area (cm^2)", "Area Type"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        resultsDisplay.setName("resultsDisplay"); // NOI18N
        jScrollPane1.setViewportView(resultsDisplay);

        add(jScrollPane1, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable resultsDisplay;
    // End of variables declaration//GEN-END:variables
    
}
