/*
 * exportData.java
 *
 * Created on 10 December 2008, 22:32
 */

package iasel.gui;

import iasel.data.REntry;
import java.io.File;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.ArrayList;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import org.jdesktop.application.Action;

/**
 *
 * @author  Davd
 */
public class exportData extends javax.swing.JDialog {
    
    /** The data to export. This is set with the setData(ArrayList<REntry>)
     * method.
     */
    ArrayList<REntry> mData;
    
    /** Displays the export data dialog. When the dialog is accepted, the
     * data is exported to a file specified by the user.
     * 
     * @param data The data to export.
     */
    public static void exportData(ArrayList<REntry> data) {
        exportData ed = new exportData(null, true);
        ed.setData(data);
        ed.setVisible(true);
    }
    
    /** Creates new form exportData */
    public exportData(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }
    
    /** Sets the data to be exported.
     * 
     * @param data The data to be exported.
     */
    public void setData(ArrayList<REntry> data) {
        mData = data;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        jLabel1 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(iasel.Iasel.class).getContext().getResourceMap(exportData.class);
        setTitle(resourceMap.getString("Form.title")); // NOI18N
        setName("Form"); // NOI18N
        setResizable(false);

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        jList1.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Filename", "Tag", "Frame Pixels", "Selected Pixels", "Selected Percentage", "Selected Area (cm^2)", "Area Type" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jList1.setName("jList1"); // NOI18N
        jScrollPane1.setViewportView(jList1);

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(iasel.Iasel.class).getContext().getActionMap(exportData.class, this);
        jButton1.setAction(actionMap.get("ExportData")); // NOI18N
        jButton1.setText(resourceMap.getString("jButton1.text")); // NOI18N
        jButton1.setName("jButton1"); // NOI18N

        jButton2.setAction(actionMap.get("cancelDialog")); // NOI18N
        jButton2.setText(resourceMap.getString("jButton2.text")); // NOI18N
        jButton2.setName("jButton2"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 294, Short.MAX_VALUE)
                    .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 294, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(jButton1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton2)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 152, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton1)
                    .addComponent(jButton2))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    @Action
    public void cancelDialog() {
        setVisible(false);
    }

    @Action
    public void ExportData() {
        // Hide the form
        setVisible(false);
        
        // Figure out what columns we are supposed to show
        boolean sFilename = false, sTag = false, sFP = false, sSP = false,
                sPercentage = false, sArea = false, sAreaType = false;
        
        for (int i:jList1.getSelectedIndices()) {
            if (i == 0) sFilename = true;
            if (i == 1) sTag = true;
            if (i == 2) sFP = true;
            if (i == 3) sSP = true;
            if (i == 4) sPercentage = true;
            if (i == 5) sArea = true;
            if (i == 6) sAreaType = true;
        }
        
        // Ask the user where to export to
        JFileChooser jfc = new JFileChooser();
        jfc.setSelectedFile(new File("export.csv"));
        int result = jfc.showSaveDialog(this);
        
        // Did the user accept?
        if (result == JFileChooser.APPROVE_OPTION) {
            // Yes. Proceed with the export.
            File outputFile = jfc.getSelectedFile();
            
            if (outputFile.exists()) {
                // The target file already exists, do we want to replace it?
                int response = JOptionPane.showConfirmDialog(null, 
                        "File '" + outputFile.getAbsolutePath() + "' already" +
                        " exists.\nDo you want to replace it?", "Confirm",  
                    JOptionPane.OK_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE);
            
                if (response == JOptionPane.CANCEL_OPTION ||
                    response == JOptionPane.CLOSED_OPTION) {
                        //JOptionPane.showConfirmDialog(null,
                        //        "No data was exported.", "No data exported",
                        //        JOptionPane., 
                        //        JOptionPane.INFORMATION_MESSAGE);
                        JOptionPane.showMessageDialog(null, "No data was exported.");
                        return;          
                }
            }
            
            FileOutputStream fos = null;
            
            try {
                fos = new FileOutputStream(outputFile);
            } catch(Exception e) {
                GraphicalExceptionHandler geh = new GraphicalExceptionHandler(null, true);
                geh.uncaughtException(null, e);
            }
            PrintStream ps = new PrintStream(fos);
            
            // Output column headers
            if (sFilename) { 
                ps.print("\"Filename\"");
                if (sTag || sFP || sSP || sPercentage) ps.print(",");
            }

            if (sTag) {
                ps.print("\"Tag\"");
                if (sFP || sSP || sPercentage) ps.print(",");
            }

            if (sFP) {
                ps.print("\"Frame Pixels\"");
                if (sSP || sPercentage) ps.print(",");
            }

            if (sSP) {
                ps.print("\"Selected Pixels\"");
                if (sPercentage) ps.print(",");
            }

            if (sPercentage) {
                ps.print("\"Percentage Selected\"");
                if (sArea) ps.print(",");
            }
            
            if (sArea) {
                ps.print("\"Selected Area (cm^2)\"");
                if (sAreaType) ps.print(",");
            }
            
            if (sAreaType) {
                ps.print("\"Area Type\"");
            }

            ps.print("\n");            
            
            // Output each column if specified.
            int i = 0;
            for (REntry e:mData) {
                i++;
                if (sFilename) { 
                    ps.print("\"" + e.Filename + "\"");
                    if (sTag || sFP || sSP || sPercentage) ps.print(",");
                }
                
                if (sTag) {
                    ps.print("\"" + e.Tag + "\"");
                    if (sFP || sSP || sPercentage) ps.print(",");
                }
                
                if (sFP) {
                    ps.print(e.FramePixels.toString());
                    if (sSP || sPercentage) ps.print(",");
                }
                
                if (sSP) {
                    ps.print(e.SelectedPixels.toString());
                    if (sPercentage) ps.print(",");
                }
                
                if (sPercentage) {
                    ps.print(e.SelectedPercentage.toString());
                    if (sArea) ps.print(",");
                }
                
                if (sArea) {
                    ps.print(e.SelectedArea.toString());
                    if (sAreaType) ps.print(",");
                }
                
                if (sAreaType) {
                    ps.print("\"" + e.AreaType + "\"");
                }
                
                ps.print("\n");
            }
            
            // Close everything.
            ps.close();
            try {
                fos.close();
            } catch(Exception e) {
                GraphicalExceptionHandler geh = new GraphicalExceptionHandler(null, true);
                geh.uncaughtException(null, e);
                return;
            }
            JOptionPane.showMessageDialog(null, i + " records exported.");
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JList jList1;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables
    
}
